// Wave.cpp: CWave NX̃Cve[V
// ǂݍ߂Ȃwavet@ĈŁAvC[10/06/24]
//
// tH[}bg: 44,100 ksps, 16bit, stereo [̂]ɑΉ
// 
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "Wave.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ς߂֐ type=1:敽 2:exp->log 3:a 4:C敽 5:sigmoid else:
static double Avg(double d1, double d2, double weight, int type)
{
	double r;
	switch(type){
	case 1:
		if(d1<0.01) d1=0.01; if(d2<0.01) d2=0.01;
		return (pow(d1, 1.0-weight) * pow(d2, weight));
	case 2:
		return (log(exp(d1)*(1.0-weight) + exp(d2)*weight));
	case 3:
		return (1.0/((1.0/d1)*(1.0-weight) + (1.0/d2)*weight));
	case 4:
		r = (pow(d1+1.0, 1.0-weight) * pow(d2+1.0, weight)-1.0);
		if(r<0.0)r=0.0;
		return r;
	case 5:
		r = Avg(d1, d2, 
			1.0/(1.0+exp(-8.0*(-0.5+weight))),
			0);
	//	r = 1.0/(1.0+exp(-40.0*(-0.5+weight)));
		return r;
	default:
		return (d1*(1.0-weight) + d2*weight);
	}
	return -1.0;

}

CWave::CWave()
{
	fwave = 0;
	memset(&m_curPos, 0, sizeof(m_curPos));
	memset(&m_topPos, 0, sizeof(m_curPos));
	m_filename[0] = '\0';
}

CWave::~CWave()
{
	CloseWave();
//	printf("~CWAVE");
}

int CWave::CloseWave(){
	if(fwave) fclose(fwave);
	return 0;
}

// local
unsigned CWave::get_ushort(FILE *f)
{
    unsigned char s[2];

    if (fread(s, 2, 1, f) != 1) {
 //       fprintf(stderr, "Read error\n");
        exit(1);
    }
    return s[0] + 256U * s[1];
}

unsigned long CWave::get_ulong(FILE *f)
{
    unsigned char s[4];

    if (fread(s, 4, 1, f) != 1) {
   //     fprintf(stderr, "Read error\n");
        exit(1);
    }
    return s[0] + 256LU * (s[1] + 256LU * (s[2] + 256LU * s[3]));
}

// ԂlFvTv(>=0)
int CWave::OpenWave(const char *filename)
{
	if(fwave) fclose(fwave);
	strcpy(m_filename, filename);
	m_count = 0;

	int i;
	unsigned long len;
	unsigned char s[10];

	if ((fwave = fopen(filename, "rb")) == NULL) {
		return 0;
	}
	if (fread(s, 4, 1, fwave) != 1) {
		fclose(fwave);
		return 0;
	}
	if (memcmp(s, "RIFF", 4) != 0) {
		fclose(fwave);
		return 0;
	}
	get_ulong(fwave);
	if (fread(s, 4, 1, fwave) != 1) {
		fclose(fwave);
		return 0;
	}
	if (memcmp(s, "WAVE", 4) != 0) {
		fclose(fwave);
		return 0;
	}
	// read fmt chunk
	if (fread((void*)&m_fmt, sizeof(m_fmt), 1, fwave) != 1) {
		fclose(fwave);
		return 0;
	}
	if(memcmp(&(m_fmt.chunkID), "fmt ", 4) != 0){
		fclose(fwave);
		return 0;
	}
	if(m_fmt.wBitsPerSample!=16 || m_fmt.wFormatTag!=1) {
		//DebugMsg("ch=%d, bits=%d, ", m_fmt.wChannels, m_fmt.wBitsPerSample);
		return -1; // ΉtH[}bg
	}
	for(i=sizeof(m_fmt); i<m_fmt.chunkSize + 8; i++) { // ǂ
		fread(s, 1, 1, fwave);
	}
	m_sps = m_fmt.dwSamplesPerSec;// Tv[g

	// header read
	for(i=0; i<2; i++){
		if(fread(s, 4, 1, fwave) != 1){
			fclose(fwave);
			return 0;
		}
		len = get_ulong(fwave);
		s[4] = 0;

		if (memcmp(s, "data", 4) == 0 || memcmp(s, "data", 4) == 0) break;
		if (memcmp(s, "LIST", 4) == 0 || memcmp(s, "list", 4) == 0) {
			for(int j=0; j<len; j++) { // ǂ
				fread(s, 1, 1, fwave);
			}
			// TCYǂ
			continue;
		}
		// ext. chunk exists
//		for (int j=0; j<len; j++)
//			fgetc(fwave);


		return -2;
	}
	m_count = 0;

	m_topPos = ftell(fwave);
	m_curPos = m_topPos;

	length = len / m_fmt.wChannels / (m_fmt.wBitsPerSample/8);
	return length; //1024 sps * 512 (PTvwave)

}

// width ̃f[^ǂݍ
// stereoMode: b0 -> Stereo load / Monoral load; b15-8: channel
void CWave::LoadWaveFloat(float *wave, int width, int stereoMode, int interleaved)
{
	if(WAVE_RESAMPLE_ENABLE && m_sps != (int)WAVE_RESAMPLE_RATE){
		m_curPos += (int)((m_fmt.wChannels)*2 * (int)(width * (double)(m_sps / WAVE_RESAMPLE_RATE)));
	}else{
		m_curPos += (int)((m_fmt.wChannels)*2 * width);
	}
	int i, j, x;
	unsigned char s[10];
	long data[8];
	int channel = stereoMode >> 8; // channel:  L̒ʂ
	/*
		if(m_playMode == tGlobals::PMD_LMINUSR){
			channel = 3;
		}else if(m_playMode == tGlobals::PMD_LCH){
			channel = 1;
		}else if(m_playMode == tGlobals::PMD_RCH){
			channel = 2;
		}else if(m_playMode == tGlobals::PMD_LPLUSR){
			channel = 4;
		}else if(m_playMode == tGlobals::PMD_LMINUSR_SPECT){
			channel = 8;
		}
		else if(m_playMode == tGlobals::PMD_KARAOKE){
			channel = 16;
		}
	*/
	stereoMode = stereoMode & 1;

	if(WAVE_RESAMPLE_ENABLE && m_sps != (int)WAVE_RESAMPLE_RATE){
		int width2 = width * (double)(m_sps / WAVE_RESAMPLE_RATE);
		float* buf = new float[width2 * (1+stereoMode) + 1];

		// assuming width is not so long
		for(j=0; j<width2; j++) {
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						if(stereoMode){
							while(j < width2){
								buf[j] = buf[j+width2] = 0.0f;
								j++;
							}
						}else{
							while(j < width2){
								buf[j++]=0.0f;
							}
						}
						goto LoadWaveFloatEx_Finalize;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						if(stereoMode){
							while(j < width2){
								buf[j] = buf[j+width2] = 0.0f;
								j++;
							}
						}else{
							while(j < width2){
								buf[j++]=0.0f;
							}
						}
						goto LoadWaveFloatEx_Finalize;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				if(stereoMode && m_fmt.wChannels == 2){
					buf[j+i*width2] = (float) (x/32768.0);
				}else{
					data[i] = x; // stereo -> mono conversion
				}
			}

			if(channel == 1){ // Lch
				data[0] = data[0];
			}else if(channel == 2){ // Rch
				data[0] = data[1];
			}else if(channel == 3 || channel == 16){
				data[0] = (data[0] - data[1]) / 2;
			}else{
				data[0] = (data[0] + data[1]) / 2;
			}
			//data /= m_fmt.wChannels;
			if(stereoMode){
				if(m_fmt.wChannels != 2){
					buf[j] = buf[j+width2] = (float)(data[0] / 32768.0);
				}
			}else{
				buf[j] = (float)(data[0] / 32768.0);
			}
			m_count++;
		}
LoadWaveFloatEx_Finalize:
		for(j=0; j<width; j++) {
			double w = j * (m_sps / WAVE_RESAMPLE_RATE);
			if((int)w+1 < (int)width2){
				if(stereoMode && interleaved){
					wave[2*j]   = Avg(buf[(int)w], buf[(int)w+1], w-(int)w, 0);
					wave[2*j+1] = Avg(buf[width2+(int)w], buf[width2+(int)w+1], w-(int)w, 0);
				}else{
					wave[j] = Avg(buf[(int)w], buf[(int)w+1], w-(int)w, 0);
					if(stereoMode){
						wave[j+width] = Avg(buf[width2+(int)w], buf[width2+(int)w+1], w-(int)w, 0);
					}
				}
			}else{
				if(stereoMode && interleaved){
					wave[2*j]   = buf[(int)w];
					wave[2*j+1] = buf[width2+(int)w];
				}else{
					wave[j] = buf[(int)width2-1];
					if(stereoMode){
						wave[j+width] = buf[width2+(int)w-1];
					}
				}
			}
		}
		delete [] buf;
	}else{
		for(j=0; j<width; j++) {
			data[0] = 0;
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						if(stereoMode) {
							while(j < width){ 
								wave[j] = wave[j+width] = 0.0f;
								j++;
							}
						}else{
							while(j < width){ 
								wave[j++]=0.0f;
							}
						}
						return;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						if(stereoMode) {
							while(j < width){ 
								wave[j] = wave[j+width] = 0.0f;
								j++;
							}
						}else{
							while(j < width){
								wave[j++]=0.0f;
							}
						}
						return;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				if(stereoMode && m_fmt.wChannels == 2){
					if(interleaved){
						wave[2*j+i] = (float)(x/32768.0);
					}else{
						wave[j+i*width] = (float) (x/32768.0);
					}
				}else{
					data[i] = x; // stereo -> mono conversion
				}
			}

			if(channel == 1){ // Lch
				data[0] = data[0];
			}else if(channel == 2){ // Rch
				data[0] = data[1];
			}else if(channel == 3 || channel == 16){
				data[0] = (data[0] - data[1]) / 2;
			}else{
				data[0] = (data[0] + data[1]) / 2;
			}

			//data /= m_fmt.wChannels;
			if(stereoMode) {
				if(m_fmt.wChannels != 2) {
					if(interleaved){
						wave[2*j] = wave[2*j+1] = (float)(data[0] / 32768.0);
					}else{
						wave[j] = wave[j+width] = (float)(data[0] / 32768.0);
					}
				}
			}else {
				wave[j] = (float)(data[0] / 32768.0);
			}
			m_count++;
		}
	}

}
// width ̃f[^ǂݍ (wave: width*2*sizeof(float) TCY̔z)
// Left -> Right ̏ɓǂݍ
void CWave::LoadWaveFloatStereo(float *wave, int width, int interleaved)
{
	LoadWaveFloat(wave, width, 1, interleaved);
	return;

	m_curPos += (int)((m_fmt.wChannels)*2 * width);
	int i, j, x;
	unsigned char s[10];
	long data;
	for(j=0; j<width; j++) {
		data = 0;
		if(m_fmt.wChannels == 2){// wave t@CXeIŋL^Ă
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						while(j < width){ 
							wave[j++] = 0.0f;
						}
						return;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						while(j < width){
							wave[j++]=0.0f;
						}
						return;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				if(interleaved == 0){
					wave[j+i*width] = (float)(x / 32768.0);
				}else{
					wave[j*2+i] = (float)(x / 32768.0);
				}
			}
			m_count++;
		}else{
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						while(j < width){ 
							wave[j++]=0.0f;
						}
						return;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						while(j < width){
							wave[j++]=0.0f;
						}
						return;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				data += x; // stereo -> mono conversion
			}
			data /= m_fmt.wChannels;
			if(interleaved == 0){
				wave[j] = wave[j+width] = (float)(data / 32768.0);
			}else{
				wave[j*2] = wave[j*2+1] = (float)(data / 32768.0);
			}
			m_count++;
		}
	}

}

// width ̃f[^ǂݍ
void CWave::LoadWaveShort(short *wave, int width, int stereoMode, int interleaved)
{
	if(WAVE_RESAMPLE_ENABLE && m_sps != (int)WAVE_RESAMPLE_RATE){
		m_curPos += (int)((m_fmt.wChannels)*2 * (int)(width * (double)(m_sps / WAVE_RESAMPLE_RATE)));
	}else{
		m_curPos += (int)((m_fmt.wChannels)*2 * width);
	}
	int i, j, x;
	unsigned char s[10];
	long data;
	if(stereoMode > 1) stereoMode = 1;

	if(WAVE_RESAMPLE_ENABLE && m_sps != (int)WAVE_RESAMPLE_RATE){
		int width2 = width * (double)(m_sps / WAVE_RESAMPLE_RATE);
		float* buf = new float[width2 * (1+stereoMode) + 1];

		// assuming width is not so long
		for(j=0; j<width2; j++) {
			data = 0;
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						if(stereoMode){
							while(j < width2){
								buf[j] = buf[j+width2] = 0.0f;
								j++;
							}
						}else{
							while(j < width2){
								buf[j++]=0.0f;
							}
						}
						goto LoadWaveShortEx_Finalize;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						if(stereoMode){
							while(j < width2){
								buf[j] = buf[j+width2] = 0.0f;
								j++;
							}
						}else{
							while(j < width2){
								buf[j++]=0.0f;
							}
						}
						goto LoadWaveShortEx_Finalize;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				if(stereoMode && m_fmt.wChannels == 2){
					buf[j+i*width2] = (float) (x/32768.0);
				}else{
					data += x; // stereo -> mono conversion
				}
			}
			data /= m_fmt.wChannels;
			if(stereoMode){
				if(m_fmt.wChannels != 2){
					buf[j] = buf[j+width2] = (float)(data / 32768.0);
				}
			}else{
				buf[j] = (float)(data / 32768.0);
			}
			m_count++;
		}
LoadWaveShortEx_Finalize:
		for(j=0; j<width; j++) {
			double w = j * (m_sps / WAVE_RESAMPLE_RATE);
			if((int)w+1 < (int)width2){
				if(stereoMode && interleaved){
					wave[2*j]   = (short)(32700 * Avg(buf[(int)w], buf[(int)w+1], w-(int)w, 0));
					wave[2*j+1] = (short)(32700 * Avg(buf[width2+(int)w], buf[width2+(int)w+1], w-(int)w, 0));
				}else{
					wave[j] = (short)(32700 * Avg(buf[(int)w], buf[(int)w+1], w-(int)w, 0));
					if(stereoMode){
						wave[j+width] = (short)(32700 * Avg(buf[width2+(int)w], buf[width2+(int)w+1], w-(int)w, 0));
					}
				}
			}else{
				if(stereoMode && interleaved){
					wave[2*j]   = (short)(32700 * buf[(int)w]);
					wave[2*j+1] = (short)(32700 * buf[width2+(int)w]);
				}else{
					wave[j] = (short)(32700 * buf[(int)w]);
					if(stereoMode){
						wave[j+width] = (short)(32700 * buf[width2+(int)w-1]);
					}
				}
			}
		}
		delete [] buf;
	}else{
		for(j=0; j<width; j++) {
			data = 0;
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						if(stereoMode) {
							while(j < width*2){ 
								wave[j++]= 0;
							}
						}else{
							while(j < width){ 
								wave[j++]=0;
							}
						}
						return;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						if(stereoMode) {
							while(j < width*2){ 
								wave[j++] = 0;
							}
						}else{
							while(j < width){
								wave[j++]=0;
							}
						}
						return;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				if(stereoMode && m_fmt.wChannels == 2){
					if(interleaved){
						wave[2*j+i] = x;
					}else{
						wave[j+i*width] = x;
					}
				}else{
					data += x; // stereo -> mono conversion
				}
			}
			data /= m_fmt.wChannels;
			if(stereoMode) {
				if(m_fmt.wChannels != 2) {
					if(interleaved){
						wave[2*j] = wave[2*j+1] = (short)data;
					}else{
						wave[j] = wave[j+width] = (short)data;
					}
				}
			}else {
				wave[j] = (short)data;
			}
			m_count++;
		}
	}
	/*
	m_curPos += (int)((m_fmt.wChannels)*2 * width);
	int i, j, x;
	unsigned char s[10];
	long data;
	for(j=0; j<width; j++) {
		data = 0;
		for(i=0; i<m_fmt.wChannels; i++) {
			if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
				if((x = fgetc(fwave)) == EOF) {
					while(j < width){ 
						wave[j++]=0;
					}
					return;
				}
				x -= 128;
				x *= 256;
			}else{ // 16bit wave
				if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
					while(j < width){
						wave[j++]=0;
					}
					return;
				}
				x = (short)(s[0] + 256*s[1]);
			}
			data += x; // stereo -> mono conversion
		}
		data /= m_fmt.wChannels;
		wave[j] = data;
		m_count++;
	}
*/
}
// width ̃f[^ǂݍ (wave: width*2*sizeof(short) TCY̔z)
// C^[uœǂݍ
void CWave::LoadWaveShortStereo(short *wave, int width, int interleaved)
{
	LoadWaveShort(wave, width, 1, interleaved);
	return;

	m_curPos += (int)((m_fmt.wChannels)*2 * width);
	int i, j, x;
	unsigned char s[10];
	long data;
	for(j=0; j<width; j++) {
		data = 0;
		if(m_fmt.wChannels == 2){// wave t@CXeIŋL^Ă
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						while(j < width){ 
							wave[j*2] = wave[j*2+1] = 0;
							j++;
						}
						return;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						while(j < width){
							wave[j*2] = wave[j*2+1] = 0;
							j++;
						}
						return;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				if(interleaved == 0){
					wave[j+i*width] = x;
				}else{
					wave[j*2+i] = x;
				}
			}
			m_count++;
		}else{ // wave t@CmŋL^Ă
			for(i=0; i<m_fmt.wChannels; i++) {
				if(m_fmt.wBitsPerSample <= 8) { // 8bit wave
					if((x = fgetc(fwave)) == EOF) {
						while(j < width){ 
							wave[j*2] = wave[j*2+1] = 0;
							j++;
						}
						return;
					}
					x -= 128;
					x *= 256;
				}else{ // 16bit wave
					if(fread(s, 2, 1, fwave) != 1){ // f[^[hG[
						while(j < width){
							wave[j*2] = wave[j*2+1] = 0;
							j++;
						}
						return;
					}
					x = (short)(s[0] + 256*s[1]);
				}
				data += x; // stereo -> mono conversion
			}
			data /= m_fmt.wChannels;
			if(interleaved == 0){
				wave[j] = wave[j+width] = data;
			}else{
				wave[j*2] = wave[j*2+1] = data;
			}
			m_count++;
		}
	}
}


// t@CʒuύX
// Py[WF1024 x 512 |Cg
void CWave::SetPrevPage()
{
	m_curPos -= 512 * 1024 * m_fmt.wChannels * 2; //1|Cg2bytes (16bit wave)Ɖ
	fseek(fwave, m_curPos, SEEK_SET);
}
// t@CʒuύX
// Py[WF1024 x 512 |Cg
void CWave::SetNextPage()
{
	m_curPos += 512 * 1024 * m_fmt.wChannels * 2; //1|Cg2bytes
	fseek(fwave, m_curPos, SEEK_SET);
}
// t@CʒuύX
void CWave::SetTopPage()
{
	m_curPos = m_topPos; //1|Cg2bytes
	fseek(fwave, m_curPos, SEEK_SET);
}

// t[Ԃ
int CWave::GetSampleLength()
{
	if(WAVE_RESAMPLE_ENABLE){ // 44100 Hz TvZ
		return length * (double)(WAVE_RESAMPLE_RATE / m_sps);
	}else{
		return length;
	}
}

// f[^_Pʂł݈̌ʒu̎w (pos=0 : ŏ̃f[^_w)
int CWave::SetPos(int newPos)
{
	if(WAVE_RESAMPLE_ENABLE){
		m_curPos = m_topPos + ((long)(newPos * (double)(m_sps / WAVE_RESAMPLE_RATE)) * m_fmt.wChannels * 2 );
	}else{
		m_curPos = m_topPos + (newPos * m_fmt.wChannels * 2);
	}
	if(fseek(fwave, m_curPos, SEEK_SET)) return -1;
	
	return 0;
}

// Wave t@Cói[hƂ͕ʂɃNX̃\[Xpӂj
// 16bit, stereo, 44,100 khz Œ
int CWave::OutputWave(const char *filename, CWave::tOutputWaveFormat* pFormat)
{

	if(fwave) return -1;
	strcpy(m_filename, filename);
	m_count = 0;
	m_wroteFrameCnt = 0;

	tOutputWaveFormat defaultFormat;
	defaultFormat.samplePerSec  = (int)WAVE_RESAMPLE_RATE;
	defaultFormat.bytePerSample = 2;
	defaultFormat.channel = 2;
	if(pFormat == NULL){
		pFormat = &defaultFormat;
	}
	m_outputFormat = *pFormat;

	unsigned long len;
	unsigned char s[10];

	// initiliza fmt chunk structure
	// Only work in LSB-first computer.
	tFormatChunk chunk;
	memcpy(&chunk.chunkID, "fmt ", 4);
	chunk.chunkSize  = 16;
	chunk.wFormatTag = 1;
	chunk.wChannels  = m_outputFormat.channel;
	chunk.dwSamplesPerSec  = m_outputFormat.samplePerSec;
	chunk.wBitsPerSample   = 8*m_outputFormat.bytePerSample;
	chunk.wBlockAlign      = (chunk.wBitsPerSample/8) * chunk.wChannels;
	chunk.dwAvgBytesPerSec = chunk.dwSamplesPerSec * chunk.wBlockAlign;


	if ((fwave = fopen(filename, "wb+")) == NULL) {
		return -1;
	}
	// riff tag
	memcpy(s, "RIFF", 4);
	if (fwrite(s, 4, 1, fwave) != 1) {
		fclose(fwave);
		return -1;
	}
	// filesize 4[byte] : t@CTCY - 8[byte] Ƃ肠 0 ɂĂ
	len = 0;
	fwrite(&len, 4, 1, fwave);//

	// fmt chunk
	memcpy(s, "WAVE", 4);
	if(fwrite(s, 4, 1, fwave) != 1){
		fclose(fwave);
		return -1;
	}//

	if(fwrite(&chunk, sizeof(chunk), 1, fwave) != 1){
		fclose(fwave);
		return -1;
	}

	// data chunk
	memcpy(s, "data", 4);
	if(fwrite(s, 4, 1, fwave) != 1){
		fclose(fwave);
		return -1;
	}
	// filesize 4[byte] : t[TCY[byte] Ƃ肠 0 ɂĂ
	len = 0;
	if(fwrite(&len, 4, 1, fwave) != 1){
		fclose(fwave);
		return -1;
	}


	return 0; 

}

// I
int CWave::OutputWaveFinalize()
{
	if(fwave == NULL) return -1;

	// ꂾ2*4oCg]vɏ܂Ă܂
	// ̂ŁA␳
	m_wroteFrameCnt += 2;

	// filesize - 8 byte
	fseek(fwave, 4, SEEK_SET);
	unsigned long len = m_wroteFrameCnt * (m_outputFormat.bytePerSample * m_outputFormat.channel)
		+ sizeof(tFormatChunk) + 12;
	fwrite(&len, 4, 1, fwave);
	fseek(fwave, 12+sizeof(tFormatChunk)+4, SEEK_SET);
	len = m_wroteFrameCnt * (m_outputFormat.bytePerSample * m_outputFormat.channel) ;
	fwrite(&len, 4, 1, fwave);

	fclose(fwave);
	fwave = 0;
	return 0;
}

int CWave::OutputWaveFrameByMono(void *data, int size)
{
	if(fwave == NULL) return -1;

	// input: monoral frame array
	// output: stereo wave file
	if(m_outputFormat.bytePerSample == 2){ // 16bit
		short* pDataPointer = (short*) data;
		for(int i=0; i<size; i++){
			fwrite(&(pDataPointer[i]), 2, 1, fwave);
			if(m_outputFormat.channel == 2){
				fwrite(&(pDataPointer[i]), 2, 1, fwave);
			}
			m_wroteFrameCnt++;
		}
	}else{ // 8bit
		unsigned char* pDataPointer = (unsigned char*) data;
		for(int i=0; i<size; i++){
			fwrite(&(pDataPointer[i]), 1, 1, fwave);
			if(m_outputFormat.channel == 2){
				fwrite(&(pDataPointer[i]), 1, 1, fwave);
			}
			m_wroteFrameCnt++;
		}
	}
	return 0;
}

// 16bit, 2channel
int CWave::OutputWaveFrameByStereo( short *dataLeft,  short *dataRight, int size)
{
	if(fwave == NULL) return -1;
	if(m_outputFormat.channel != 2) return -2;
	if(m_outputFormat.bytePerSample != 2) return -3;

	// input: mono frame array of each channel
	// output: stereo wave file
	for(int i=0; i<size; i++){
		fwrite(&(dataLeft[i]),  2, 1, fwave);
		fwrite(&(dataRight[i]), 2, 1, fwave);
		m_wroteFrameCnt++;
	}
	return 0;
}
