// Wave.h: CWave NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVE_H__57FEFC84_E80A_4C92_AFF2_FACCA4B7936F__INCLUDED_)
#define AFX_WAVE_H__57FEFC84_E80A_4C92_AFF2_FACCA4B7936F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef WIN32
typedef  unsigned char  uint8_t;
typedef  unsigned short  uint16_t;
typedef  signed short  int16_t;
typedef  unsigned long  uint32_t;
typedef  signed long  int32_t;
#else
#include <stdint.h>
#endif

#ifndef WAVE_RESAMPLE_RATE
#define WAVE_RESAMPLE_RATE 44100
#endif
#ifndef WAVE_RESAMPLE_ENABLE
#define WAVE_RESAMPLE_ENABLE 0
#endif


// stdafx.h Œ`ׂ
//#define WAVE_RESAMPLE_ENABLE 1 // [16/08/07]
//#define WAVE_RESAMPLE_RATE 44100 // [16/08/07]

class CWave  
{
private:
	char m_filename[2560];
	int m_wroteFrameCnt;
//	int bits;
//	int channels;
	long m_count;
	unsigned long get_ulong(FILE *f);
	unsigned get_ushort(FILE* f);
	FILE* fwave;
//	fpos_t m_topPos, m_curPos;
	long m_topPos, m_curPos;
	int length;
	int m_sps;
public:
	struct tOutputWaveFormat{
		int samplePerSec;
		int bytePerSample;
		int channel;
	};
public:
	// out 
	int OutputWaveFrameByStereo(short* dataLeft, short* dataRight, int size);
	int OutputWaveFrameByMono(void* data, int size);
	int OutputWaveFinalize();
	int OutputWave(const char* filename, tOutputWaveFormat* pFormat = NULL);
	// pos
	int SetPos(int newPos);
	int GetSampleLength();
	void SetTopPage();
	void SetNextPage();
	void SetPrevPage();
	char* GetFileName(){ return m_filename;} // tpXŕԂ
	int IsEOF(void){return feof(fwave);}
	int IsOpen(){ return (fwave!=0)? 1: 0; };
	int OpenWave(const char* filename);
	int CloseWave();
	void LoadWaveFloat(float* wave, int width, int stereoMode = 0, int interleaved = 0);
	void LoadWaveFloatStereo(float* wave, int width, int interleaved = 0);
	void LoadWaveShort(short* wave, int width, int stereoMode = 0, int interleaved = 1);
	void LoadWaveShortStereo(short* wave, int width, int interleaved = 1);
	CWave();
	virtual ~CWave();

	#define ChunkID 'fmt '   /* chunkID for Format Chunk. NOTE: There is a space at the end of this ID. */ 
	struct tFormatChunk{
		uint32_t	chunkID; // "fmt "
		int32_t		chunkSize; // sizeof(tFormatChunk)-8 = 16
		int16_t		wFormatTag;
		uint16_t	wChannels;
		uint32_t	dwSamplesPerSec; 
		uint32_t	dwAvgBytesPerSec;
		uint16_t	wBlockAlign; 
		uint16_t	wBitsPerSample;
	/* Note: there may be additional fields here, depending upon wFormatTag. */ 
	} ;
	int GetSPS(){
		return m_sps;
	};
private:
	tFormatChunk m_fmt;
	tOutputWaveFormat m_outputFormat;
};

#endif // !defined(AFX_WAVE_H__57FEFC84_E80A_4C92_AFF2_FACCA4B7936F__INCLUDED_)
