#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>

double GetCPUTemp()
{
	FILE* fp = fopen("/sys/class/thermal/thermal_zone0/temp", "rt");
	if(fp){
		char buf[64];
		fread(buf, 64, 1, fp);
		double temp = (double)atoi(buf) / 1000.0;
		fclose(fp);
		return temp;
	}else{
		return 0;
	}
}

// print current time + temp value
int main(int argc, char** argv)
{
	if(argc != 2) return -1;

	FILE* fp = fopen(argv[1], "at");
	if(fp){
		time_t timer;
		time(&timer);
		struct tm* t = localtime(&timer); 
		double cpuTemp = GetCPUTemp();
		fprintf(fp, "%02d/%02d/%02d %02d:%02d:%02d %.1f\n", 
			t->tm_year%100, t->tm_mon+1, t->tm_mday,
			t->tm_hour, t->tm_min, t->tm_sec,
			cpuTemp);

		fclose(fp);
	}else{
		printf("Erorr: File can't open [%s]\n", argv[1]);
	}
	return 0;
}

